<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>CS551 Final Project - Result 1</title>
</head>

<body topmargin="0" leftmargin="0" background="BACKGRD4.bmp" bgproperties="fixed">
<% 
Dim Cover(30,5)
' save the fragment-location information
Dim FragTable(9,5)
' counting the number of different RECs
intRecCounter=0
' counting the REC number of those unfragmented relations
intRecUCounter=0
' counting the current Cover number
intCCounter=0

Sub AddRec(intCoverCounter, intR)
	Cover(intCoverCounter, 0)=Cover(intCoverCounter, 0) + ", R" + CStr(intR) 
	call RECAssign(intCoverCounter, intR)
End Sub

Sub CoverAssign(strCoverPath, intCoverCounter, intR)
	intOffset=2
	intIndex=1
	Cover(intCoverCounter, 0)="R" + CStr(intR)
	call RECAssign(intCoverCounter, intR)
	do while (intOffset <= Len(strCoverPath))
		Cover(intCoverCounter, intIndex)="Site" + Right(Left(strCoverPath,intOffset),1)
		intOffset = intOffset + 2
		intIndex = intIndex + 1
	loop
End Sub

Sub RECAssign(intCover, intRelation)
	'intREC=1
	strCover="Cover" + CStr(intCover)
	strR="R" + CStr(intRelation)
	'strRec="REC" + CStr(intREC)
	
	strTempFrag = strR + "_Fragments"
		
	do until (InString(Session(strRec),strCover) and (Session(strTempFrag)=1 or Dependent(Session(strRec),intRelation))) or (intREC > intRecCounter)
		intREC= intREC + 1
		strRec="REC" + CStr(intREC)
	loop

	if (intREC <= intRecCounter) then	
		' found an existing REC that this relation belongs to
		Session(strRec) = Session(strRec) + strR
	else
		' create a new REC for this relation
		intRecCounter = intRecCounter + 1 	
		strRec="REC" + CStr(intRecCounter)
		Session(strRec) = strCover + "," + strR
	end if		

End Sub

Function Dependent(strRecord, intRelation)
	Dependent=false
	if strRecord="" then
		exit Function
	else
		if 	Right(Left(strRecord,7),1)="," then
			intRinREC=9
		else 
			intRinREC=10
		end if		
		strCheck1="PD00"
		strCheck2="PD00"
		do until Len(strRecord)<intRinREC or Session(strCheck1)=1 or Session(strCheck2)=1
			intOffset = intRinREC
			strCheck1 = "PD" + Right(Left(strRecord, intOffset),1) + CStr(intRelation)
			strCheck2 = "PD" + CStr(intRelation) + Right(Left(strRecord, intOffset),1)
			'response.write "strRecord='" & strRecord & "', strCheck1='" & strCheck1 & "'<BR>"
			intRinREC = intRinREC + 2
		loop
		if Session(strCheck1)=1 or Session(strCheck2)=1 then
			' Relation-intRelation has dependency with some relation in REC-strRecord
			Dependent=true
		end if	
	end if	
End Function
	
Sub CoverPrint(intCover)
	response.write "Cover" & intCover & " = (RooT"
	for intCount=1 to 5
		if Cover(intCover, intCount) <> "" then
			response.write " > " & Cover(intCover, intCount)
		end if		
	next
	response.write ") - {" & Cover(intCover, 0) & "}<BR>"
End Sub	

Sub PrintPath(intCover)
	response.write "RooT"
	for intCount=1 to 5
		if Cover(intCover, intCount) <> "" then
			response.write " > " & Cover(intCover, intCount)
		end if		
	next
End Sub	

Sub PrintRec(intCover)
	response.write "{" & Cover(intCover, 0) & "}"
End Sub	
		
Function CoverSearch(strCover)
	CoverSearch=0
	
	' check if this cover exists
	intCC=1
	do while (intCC <= intCCounter and Cover(intCC, 0) <>"")
		' convert a cover to a string
		strCoverStr=""		
		for intC=1 to 5
			if Cover(intCC, intC) <> "" then 
				strCoverStr = strCoverStr + "S" + Right(Cover(intCC, intC),1)
			end if
		next	
		
		blnDifferent = StrComp(strCoverStr, strCover)
		if not(blnDifferent) then
			CoverSearch=intCC
			exit Function
		end if	
		intCC=intCC+1
	loop			
End Function
	
Function CoverMatch(strCover, intR)
	intOffset=2
	intCount=1
	strTemp = "R" + CStr(intR) + "_Fragments"
	CoverMatch = false
	
	do while (intCount <= Session(strTemp)) and (intOffset <= Len(strCover))
		strSite=Right(Left(strCover,intOffset),1)
		intSite=FragTable(intR,CInt(strSite))
		if intSite <> intCount then
			CoverMatch = false
			exit Function
		else
			intOffset = intOffset + 2
			intCount = intCount + 1
		end if	
	loop
	
	if (intCount = Session(strTemp)+1) and (intOffset = Len(strCover)+2) then 
		CoverMatch = true
	else
		CoverMatch = false
	end if	

End Function	

Function InString(strSource, strTarget)
	InString=false
	'response.write "Comparing " & strSource & " and  " & strTarget & "<BR>"
	for intOffset=1 to Len(strSource)
		if InStr(intOffset, strSource, strTarget) then
			InString = true
			exit Function
		end if
	next			
End Function	

Function SubPath(strSCover, strSRECU)
	SubPath=true
	'response.write "Checking if '" & strSCover & "' is in '" & strSRECU & "'...<BR>" 
	intCoverLen=Len(strSCover)
	intRECULen=Len(strSRECU)
	intSSS=2
	do while (intSSS<=intCoverLen) and SubPath
		strCheck = Right(Left(strSCover,intSSS),2)
		if not InString(strSRECU, strCheck) then
			SubPath=false
		else
			intSSS = intSSS + 2	
		end if
	loop	
End Function

Function ValidCover(strCover)
	ValidCover=true
	intOffset=2
	do while (intOffset <= Len(strCover))
		strSite=Right(Left(strCover,intOffset),2)
		strRest=Right(strCover, Len(strCover)-intOffset)
		if InString(strRest, strSite)=true then
			ValidCover = false
			exit Function
		else
			intOffset = intOffset + 2
		end if	
	loop
End Function	

	Session("Query")=request.form("Query")
	'response.write "Query is submitted at " & Session("Query") & "<BR>"

	' Save the fragment-location information
	
	for intRCounter=1 to Session("NumOfRelations")
		'response.write "R" & intRCounter & ":"
		for intSCounter=1 to Session("NumOfSites")
			strTempName="R" + CStr(intRCounter) + "_Site" + CStr(intSCounter) 
			strFragment=request.form(strTempName)
			'if strFragment="N/A", save value as -1
			'if strFragment="Rx", save value as 0
			'if strFragment="Fxy_Sz", save vlues as y
			if strFragment="N/A" then
				FragTable(intRCounter, intSCounter)=-1
			elseif Left(strFragment,1)="R" then
				FragTable(intRCounter, intSCounter)=0
			else 
				FragTable(intRCounter, intSCounter)=CInt(Right(Left(strFragment,3),1))	
			end if
			'response.write FragTable(intRCounter, intSCounter) & ", "
		next
		'response.write "<br>"	
	next	
	
	' Save the RECU for those unfragmented relations
	for intRelation=1 to Session("NumOfRelations")
		strTempFrag = "R" + CStr(intRelation) + "_Fragments"
		if Session(strTempFrag)=1 then
			intRecUCounter = intRecUCounter + 1
			'strTempRECU = "RECU" + CStr(intRecUCounter)
			'Session(strTempRECU) = "R" + CStr(intRelation) + ","
			strTempRECU = "R" + CStr(intRelation)
			Session(strTempRECU) = ""
			for intSite=1 to Session("NumOfSites")
				if FragTable(intRelation, intSite)=0 then
					Session(strTempRECU) = Session(strTempRECU) + "S" + CStr(intSite)
				end if
			next
		end if
	next
			
	' Search all possible paths to creat valid covers
	' use Site(n) to form a possilbe path, initialize to 0
	Dim Sites(5)
	for intCount=0 to 5
		Sites(intCount)=0
	next	
		
	intTop=1
	do while (intTop <> 0)
		Sites(intTop) = Sites(intTop) + 1
		if Sites(intTop) = Session("NumOfSites")+1 	then
			Sites(intTop) = 0
			intTop = intTop - 1
		else
			strPath=""
			for intIndex=1 to Session("NumOfSites")	
				if Sites(intIndex) <> 0 then
					strPath = strPath + "S" + CStr(Sites(intIndex))
				end if
			next
			'response.write strPath
			
			if 	ValidCover(strPath) then
				for intR=1 to Session("NumOfRelations")
				
					if CoverMatch(strPath, intR) then
							intCoverSearch = CoverSearch(strPath)
							if intCoverSearch > 0 then
								call AddRec(intCoverSearch, intR)
							else	
								intCCounter = intCCounter + 1
								call CoverAssign(strPath, intCCounter, intR)
							end if	
					end if
					
				next
				intTop = intTop + 1	
			end if
			
			if intTop = Session("NumOfSites")+1 then
				intTop = intTop - 1
			end if	
			
		end if
	loop			
	
'for intCoverIndex=1 to intCCounter
'	response.write "Cover" & intCoverIndex & "="
'	call PrintPath(intCoverIndex)
'	response.write "<BR>"
'next	
'for intTT=1 to intRecCounter 
'	strTT="REC" + CStr(intTT)
'	response.write "Session(REC" & intTT & ")='" & Session(strTT) & "'<BR>"
'next

for intRR=1 to Session("NumOfRelations") 
	strTempFrag = "R" + CStr(intRR) + "_Fragments"
	strRR = "R" + CStr(intRR)
	if Session(strTempFrag)=1 then
		'response.write "Session(R" & intRR & ")='" & Session(strRR) & "'<BR>"
		
		intCC=1
		do while (intCC <= intCCounter and Cover(intCC, 0) <>"")
			' convert a cover to a string
			strCoverStr=""		
			for intC=1 to 5
				if Cover(intCC, intC) <> "" then 
					strCoverStr = strCoverStr + "S" + Right(Cover(intCC, intC),1)
				end if
			next	
		
			blnFound = SubPath(strCoverStr, Session(strRR))
			if blnFound then
				'response.write "Find path '" & strCoverStr & "' in '" & Session(strRR) & "'!<BR>"
				call AddRec(intCC, intRR)
			end if

			intCC=intCC+1
		loop	
		
	end if
next

%>
<div align="justify">
  <table border="0" width="100%" cellspacing="0" cellpadding="0" height="1" style="font-family: Arial; font-size: 10pt; font-weight: bold">
    <tr>
      <td width="2%" height="1" bgcolor="#D2D2D2">
        <p align="center">&nbsp;</td>
      <td width="49%" height="1" bgcolor="#D2D2D2">
        <p align="left"><b><font color="#000000" face="Arial" size="2">CS551
        Distributed Database System Final Project</font></b></td>
      <td width="28%" height="1" bgcolor="#D2D2D2">
        <p align="right"><b><font color="#000000" face="Arial" size="2">By
        Shuang Xu, 06/04/2002</font></b></td>
      <td width="35%" height="1" bgcolor="#D2D2D2">&nbsp;</td>
    </tr>
    <tr>
      <td width="7%" height="1" bgcolor="#000000">&nbsp;</td>
      <td width="58%" height="1" bgcolor="#000000" colspan="2">
        <marquee style="color: #FFFFFF; font-size: 12pt; font-family: Arial; font-weight: bold">Implementation
        of Distributed Query Processing Strategy Using Placement Dependency</marquee>
      </td>
      <td width="35%" height="1" bgcolor="#000000">&nbsp;</td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">&nbsp;</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">Here is the result of all the
        available covers, in your specified case.</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">
        <hr>
      </td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">
        <form method="POST" action="result2.asp">
          <p><font size="4"><b><img border="0" src="gg2.gif">
          RESULT 1:</b></font></p>
          <table border="1" width="100%" style="font-weight: bold">
            <tr>
              <td style="color: #FFFFFF" bgcolor="#000000">&nbsp;</td>
              <td bgcolor="#C0C0C0"><b>Path</b></td>
              <td bgcolor="#C0C0C0"><b>REC Records</b></td>
            </tr>
            <%
            	for intCoverIndex=1 to intCCounter
            		if Cover(intCoverIndex, 0) <>"" then
            %>
            <tr>
              <td style="color: #FFFFFF" bgcolor="#000000"><b>Cover <%=intCoverIndex%></b></td>
              <td><% call PrintPath(intCoverIndex)%></td>
              <td><% 
              		for intTTT=1 to intRecCounter
              			strCoverNum="Cover" + CStr(intCoverIndex) + ","
              			strRECNum="REC" + CStr(intTTT)
              			strDisplay=""
              			intNumIndex=Len(strCoverNum)
              			if InString(Session(strRECNum),strCoverNum) then
              				strDisplay = "{ " + Right(Session(strRECNum),Len(Session(strRECNum))-intNumIndex) + " }  " + strDisplay
              				response.write strDisplay
              			end if
              		next		
              %></td>
            </tr>
            <% 	end if
             next
            %>
          </table>
          <p>&nbsp;<b><input type="submit" value="See the Processing Strategy with Minimum Response Time !" name="B1" style="font-weight: bold"></b></p>
        </form></td>
      <td width="35%" height="1"></td>
    </tr>
  </table>
</div>

</body>

</html>
