<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>CS551 Final Project - Step 1</title>
<style fprolloverstyle>A:hover {color: #FF6600; font-weight: bold}
</style>
</head>

<body topmargin="0" leftmargin="0" background="BACKGRD4.bmp" bgproperties="fixed" link="#666666" vlink="#000080" alink="#FF0000">
<%
	Session("J0")=5
	Session("U0")=2
	Session("C0")=1
	Session("C1")=1
%>
<div align="justify">
  <table border="0" width="100%" cellspacing="0" cellpadding="0" height="1" style="font-family: Arial; font-size: 10pt; font-weight: bold">
    <tr>
      <td width="2%" height="1" bgcolor="#D2D2D2">
        <p align="center">&nbsp;</td>
      <td width="49%" height="1" bgcolor="#D2D2D2">
        <p align="left"><b><font color="#000000" face="Arial" size="2">CS551
        Distributed Database System Final Project</font></b></td>
      <td width="28%" height="1" bgcolor="#D2D2D2">
        <p align="right"><b><font color="#000000" face="Arial" size="2">By
        Shuang Xu, 06/04/2002</font></b></td>
      <td width="35%" height="1" bgcolor="#D2D2D2">&nbsp;</td>
    </tr>
    <tr>
      <td width="7%" height="1" bgcolor="#000000">&nbsp;</td>
      <td width="58%" height="1" bgcolor="#000000" colspan="2">
        <marquee style="color: #FFFFFF; font-size: 12pt; font-family: Arial; font-weight: bold">Implementation
        of Distributed Query Processing Strategy Using Placement Dependency</marquee>
      </td>
      <td width="35%" height="1" bgcolor="#000000">&nbsp;</td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">&nbsp;</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">This web site provides an
        implementation of an algorithm ( presented by Chengwen Liu, Hao Chen and
        Warren Krueger ) to make use of placement dependency information to
        process distributed queries. For more information, see <a href="Paper1.pdf">A
        Distributed Query Processing Strategy Using Placement Dependency</a>.</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">&nbsp;</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">Here are some assumptions and query
        processing constants ( which could be selectable in future version):<br>
        <font color="#666666">- All sites have the same processing speed<br>
        - Any two nodes in the network can communicate with each other as if
        they were directly connected<br>
        - The transmissions are assumed to be carried out in parallel if data
        are shipped from one site to many sites<br>
        - An operation cannot start until all data for the operation are
        available<br>
        - |R| denotes the size of relation R<br>
        - If we partition R into n fragments, we assume </font><font color="#0000FF">|Fi| = (1/n) x |R|
        (1&lt;=i&lt;=n)</font>
        <font color="#666666"><br>
        - If Rx is the join result of R1, R2,..., Rn, we assume </font><font color="#0000FF"> |Rx| = (1/2) x (
        |R1| + |R2| + ... + |Rn| )</font>
        <font color="#666666"><br>
        - JC(R1, R2,..., Rn) = J0 x ( |R1| + |R2| + ... + |Rn| ) denotes the
        cost of joining, where </font><font color="#0000FF"> J0 = 5</font>
        <font color="#666666"><br>
        - UC(R1, R2,..., Rn) = U0 x ( |R1| + |R2| + ... + |Rn| ) denotes the
        cost of union, where </font><font color="#0000FF"> U0 = 2</font>
        <font color="#666666"><br>
        - DC(R1, R2,..., Rn) = C0 + C1 x ( |R1| + |R2| + ... + |Rn| ) denotes
        the cost of transfering, where </font><font color="#0000FF"> C0 = C1 = 1</font></td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">&nbsp;</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">Ok, now let's get started with
        setting the number of sites and relations that are referenced in the
        query ( if you choose n relations, the query is Q = R1 join R2 join ... join Rn
      )</td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">
          <hr>
      </td>
      <td width="35%" height="1"></td>
    </tr>
    <tr>
      <td width="7%" height="1"></td>
      <td width="58%" height="1" colspan="2">
        <form method="POST" action="step2.asp">
          <p><font size="4"><b><img border="0" src="gg2.gif"> STEP 1:</b></font></p>
          <p>Number of sites: <select size="1" name="Num_Of_Sites">
            <option selected value="2">2 Sites</option>
            <option value="3">3 Sites</option>
            <option value="4">4 Sites</option>
            <option value="5">5 Sites</option>
          </select> Number of relations: <select size="1" name="Num_Of_Relations">
            <option selected value="2">2 Relations</option>
            <option value="3">3 Relations</option>
            <option value="4">4 Relations</option>
            <option value="5">5 Relations</option>
            <option value="6">6 Relations</option>
            <option value="7">7 Relations</option>
            <option value="8">8 Relations</option>
            <option value="9">9 Relations</option>
          </select>  <b><input type="reset" value="Reset" name="B2" style="font-weight: bold"><input type="submit" value="Next ->" name="B1" style="font-weight: bold"></b></p>
        </form></td>
      <td width="35%" height="1"></td>
    </tr>
  </table>
</div>

</body>

</html>
